#include "bcalendar.hpp"

using namespace eosim::core;
using namespace eosim::utils;


class ClockComp: public EntityComp {
public:
    ClockComp() {}
    ~ClockComp() {}
    bool compare (Entity* e1_, Entity* e2_) { return e1_->getClock() < e2_->getClock(); }
    
};

ClockComp c;

BCalendar::BCalendar ():  simTime(0), endSim(0), ents(EntityQueueOrdered(&c)) {}

BCalendar::~BCalendar () {}

void BCalendar::bPhase () {
    simTime = ents[0]->getClock();
    for (; simTime <= endSim && !ents.empty() && ents[0]->getClock() == simTime;) {
        Entity* temp = ents.pop();
        temp->processEvent();
    }    
}

bool BCalendar::isStopped() {
    return simTime <= endSim && !ents.empty();
}

void BCalendar::schedule (double offset_, Entity* who_) {
    who_->setClock(simTime + offset_);
    ents.push(who_);
}

void BCalendar::setEndTime (double when_) {
    endSim = when_;
}

double BCalendar::getSimTime() {
    return simTime;
}

