#include "bin.hpp"
#include <cassert>

using namespace eosim::core;


Bin::Bin(double quantity_): quantity(quantity_) {
    assert(quantity >= 0 && "Bin::Bin: Error creating a bin");
}

Bin::~Bin() {}

void Bin::acquire (double amount_) {
    assert(amount_ <= quantity && "Bin::acquiere: Error aquiring a bin"); 
        quantity -= amount_;
}

bool Bin::isAvailable (double amount_) {
    return quantity >= amount_;
}

double Bin::getQuantity() {
	return quantity;
}
