#ifndef EXPERIMENT_HPP_
#define EXPERIMENT_HPP_

#include <string>
#include "bcalendar.hpp"
#include "ccalendar.hpp"
#include "entity.hpp"
#include <eosim/dist/distmanager.hpp>
#include <eosim/dist/distribution.hpp>

namespace eosim {

namespace core {

    class Model;

	class Experiment {
	private:
		bool running;
		dist::DistManager distMan;
		BCalendar bCal;
		CCalendar cCal;
		Model* currModel;
	public:
		Experiment ();
		~Experiment();
		void run (double simTime_);
		void setModel (Model* model_);
		void schedule (double offset_, Entity* who_);
		void setSeed (unsigned long seed_);
		void registerDist (dist::Distribution* dist_);
		void registerCEvent (CEvent* cEv_);
        double getSimTime();
	};
	
}

}

#endif

