#ifndef MODEL_HPP_
#define MODEL_HPP_

#include <string>
#include "entity.hpp"
#include <eosim/dist/distribution.hpp>
#include <eosim/utils/beventmap.hpp>
#include <eosim/utils/ceventvector.hpp>

namespace eosim {

namespace statics {
    class Histogram;
}

namespace core {

    class BEvent;
    class CEvent;
    class Experiment;
	
	class Model {
	private:
		Experiment* exp;
		utils::BEventMap bEvs;

	public:
		Model();
		virtual ~Model();
		virtual void init () = 0;
		virtual void doInitialSchedules () = 0;
		void connectToExp (Experiment *exp_);
		void registerBEvent (BEvent* bEv_);
		void registerCEvent (CEvent* cEv_);
		void registerDist (dist::Distribution* dist_);
        void registerHistogram (statics::Histogram* hist_);
		void schedule (double offset_, Entity* who_, std::string what_);
        double getSimTime();
	};

}

}

#endif

