#include "renewable.hpp"
#include <cassert>

using namespace eosim::core;


Renewable::Renewable(double quantity_, double max_): Bin(quantity_), max(max_) {
    assert(quantity <= max &&  "Renewable::Renewable: Error creating a Renewable bin");
}

Renewable::~Renewable() {}

void Renewable::returnBin (double amount_) {
    assert(amount_ + quantity <= max && "Renewable::returnBin: Error returning Renewable bins"); 
    quantity += amount_;
}

double Renewable::getMax() {
	return max;
}
