#include "distmanager.hpp"
#include "numbergeneratorfactory.hpp"

using namespace eosim::dist;
using namespace eosim::utils;


DistManager::DistManager (GenType seedGenerator_): seedGenerator(NumberGeneratorFactory::make(seedGenerator_)) {}

DistManager::~DistManager () {
    delete seedGenerator;
}

void DistManager::setSeed (unsigned long seed_) {
    seedGenerator->setSeed(seed_);
    for ( unsigned int i = 0; i < dVect.size(); i++) {
        dVect[i]->setSeed(seedGenerator->nextLong());
    }
}

void DistManager::registerDist (Distribution* d) {
    dVect.push(d);
}

