#include "lognormaldist.hpp"
#include <cmath>

const double tpi = 6.2831852;

using namespace eosim::dist;


LogNormalDist::LogNormalDist(GenType gen_, double m_, double sd_):
                       Distribution(gen_), m(m_), sd(sd_) {} 


LogNormalDist::~LogNormalDist() {}

double LogNormalDist::sample() {
    double x, xs, xm;
    x = log (sd/m+1);
    xs = sqrt (x);
    xm = log (m)-0.5*x;
    return exp (sin(tpi * generator->nextDouble()) * 
           sqrt( -2 * log(generator->nextDouble())) * xs + xm);
}

