#include "normaldist.hpp"
#include <cmath>

const double tpi = 6.2831852;

using namespace eosim::dist;


NormalDist::NormalDist(GenType gen_, double m_, double sd_):
                       Distribution(gen_), m(m_), sd(sd_) {} 

NormalDist::~NormalDist() {}

double NormalDist::sample() {
    return sin(tpi * generator->nextDouble()) * 
           sqrt(-2 * log(generator->nextDouble())) * sd + m;
}

