#include "poissondist.hpp"
#include <cmath>


using namespace eosim::dist;


PoissonDist::PoissonDist(GenType gen_, double m_):
                         Distribution(gen_), m(m_) {} 

PoissonDist::~PoissonDist() {}

double PoissonDist::sample() {
    double rnd, p;
    unsigned int x;
    rnd = generator->nextDouble();
    p = exp(-m);
    x = 0;
    for (double f = p ;rnd > f; f += p) {
        x++;
        p *= (m/x);
    }
    return x;
}

