#ifndef HISTOGRAM_HPP_
#define HISTOGRAM_HPP_

#include <string>
#include <vector>

namespace eosim {

namespace core {
    class Model;
}

namespace statics {

    class Histogram {
    private:
        double lower,upper,width;
        double count,total,sosq,minX,maxX,minY,maxY;
        int cantCell;
        std::vector< double > cell;
        std::string name;
        std::string printH();
        std::string printT();
    protected:
        core::Model* model;
        Histogram(double lower_, double upper_,double width_, std::string name_);
        void log(double x_, double y_);
    public:
        virtual ~Histogram();
        void reset();
        void setModel(core::Model* model_);
        void print();
        void print(const char* path_);
        void table();
        void table(const char* path_);
        double getMaxX();
        double getMinX();
        double getMaxY();
        double getMinY();
        double getVariance();
        double getMean();
        std::string getName();
    };

}

}

#endif

