#include "timeweighted.hpp"
#include <eosim/core/model.hpp>
#include <cassert>

using namespace eosim::statics;


TimeWeighted::TimeWeighted(double lower_, double upper_,double width_, std::string name_): Histogram(lower_, upper_, width_, name_), lastTimeUsed(0) {}

void TimeWeighted::log(double x_) {
    double actTime = model->getSimTime();
    Histogram::log(x_,actTime - lastTimeUsed);
    lastTimeUsed = actTime;
}

