#include "beventmap.hpp"
#include <cassert>

using namespace eosim::utils;
using namespace eosim::core;
using namespace std;


BEventMap::BEventMap () {}

BEventMap::~BEventMap () {}

void BEventMap::put (BEvent* elem_) {
    assert(elems.find(elem_->getName()) == elems.end() && "BEventMap::put: Error inserting a BEvent in a BEventMap");
    elems[elem_->getName()] = elem_;
}

void BEventMap::remove (string key_) {
    assert(elems.find(key_) == elems.end() && "BEventMap::remove: Error removing a BEvent from a BEventMap");
    elems.erase(key_);
}

BEvent* BEventMap::operator[] (string key_) {
    BEvent* ret = elems[key_];
    assert(ret != 0 && ret->getName() == key_ && "BEventMap::operator[]: Error indexing in a BEventMap with an unregister key");
    return ret;
}

unsigned int BEventMap::size() {
    return elems.size();
}	

