#include "entityqueuefifo.hpp"
#include <cassert>

using namespace eosim::core;
using namespace eosim::utils;
using namespace std;
	

EntityQueueFifo::EntityQueueFifo() {}

EntityQueueFifo::~EntityQueueFifo() {
    for (deque<Entity*>::iterator i = elems.begin(); i != elems.end(); i++) {
        delete *i;
    }
}

void EntityQueueFifo::push(Entity* ent_) {
    elems.push_back(ent_);
}

Entity* EntityQueueFifo::pop() {
    assert(elems.size() > 0 && "EntityQueueFifo::pop: Error removing the first element of a EntityQueueFifo");
    Entity* e = elems.front();
    elems.pop_front();
    return e;
} 

void EntityQueueFifo::remove(unsigned int i_) {
    assert(i_ < elems.size() && "EntityQueueFifo::remove: Error removing an Entity from an EntityQueueFifo");
    elems.erase(elems.begin() + i_);
}

bool EntityQueueFifo::empty() {
    return elems.empty();
}

Entity* EntityQueueFifo::operator[] (unsigned int i_) {
    assert(i_ < elems.size() && "EntityQueueFifo::operator[]: Error indexing in a EntityQueueFifo");
    return elems[i_];
}

unsigned int EntityQueueFifo::size() {
    return elems.size();
}

