#include "entityqueuelifo.hpp"
#include <cassert>

using namespace eosim::core;
using namespace eosim::utils;
using namespace std;


EntityQueueLifo::EntityQueueLifo() {}

EntityQueueLifo::~EntityQueueLifo() {
    for (deque<Entity*>::iterator i = elems.begin(); i != elems.end(); i++) {
        delete *i;
    }
}

void EntityQueueLifo::push(Entity* ent_) {
    elems.push_front(ent_);
}

Entity* EntityQueueLifo::pop() {
    assert(elems.size() > 0 && "EntityQueueLifo::pop: Error removing the first element of a EntityQueueLifo");
    Entity* e = elems.front();
    elems.pop_front();
    return e;
} 

void EntityQueueLifo::remove(unsigned int i_) {
    assert(i_ < elems.size() && "EntityQueueLifo::remove: Error removing an Entity from an EntityQueueLifo");
    elems.erase(elems.begin() + i_);
}

bool EntityQueueLifo::empty() {
    return elems.empty();
}

Entity* EntityQueueLifo::operator[] (unsigned int i_) {
    assert(i_ < elems.size() && "EntityQueueLifo::operator[]: Error indexing in a EntityQueueLifo");
    return elems[i_];
}

unsigned int EntityQueueLifo::size() {
    return elems.size();
}

